#property link      "www.forex-tsd.com"      
#property copyright "www.forex-tsd.com" 

//
//
//
//
//

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  Red
#property indicator_color2  RoyalBlue
#property indicator_color3  Red
#property indicator_color4  RoyalBlue
#property indicator_color5  Yellow
#property indicator_color6  Yellow
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  1
#property indicator_width6  1

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame        = PERIOD_CURRENT;
extern int                Upper_Ma_Period  = 5;
extern int                Lower_Ma_Period  = 5;
extern ENUM_MA_METHOD     Upper_Ma_Method  = 2;
extern ENUM_MA_METHOD     Lower_Ma_Method  = 2;
extern ENUM_APPLIED_PRICE Upper_Ma_Price   = PRICE_HIGH;
extern ENUM_APPLIED_PRICE Lower_Ma_Price   = PRICE_LOW;
extern bool               alertsOn         = false;
extern bool               alertsOnCurrent  = true;
extern bool               alertsMessage    = true;
extern bool               alertsSound      = false;
extern bool               alertsNotify     = false;
extern bool               alertsEmail      = false;
extern string             soundFile        = "alert2.wav";
extern bool               ShowArrows       = false;
extern string             arrowsIdentifier = "pabars Arrows";
extern double             arrowsUpperGap   = 1.0;
extern double             arrowsLowerGap   = 1.0;
extern color              arrowsUpColor    = LimeGreen;
extern color              arrowsDnColor    = Red;
extern color              arrowsUpCode     = 241;
extern color              arrowsDnCode     = 242;
extern bool               HAOnFirst        = false;



//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double uPac[];
double lPac[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//               



int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0, Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, Buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, uPac);        
   SetIndexBuffer(5, lPac);       
   SetIndexBuffer(6, trend);
      
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(TimeFrame)+" PA Bars and Channel");   
return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}
  
//
//
//
//
//
  
int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);   
          if (returnBars) { Buffer1[0] = limit+1; return(0); }   
          
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
     for (pos=limit; pos >= 0; pos--)
     {                    
         double haClose = (Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
         double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])/2;
         double haHigh  = MathMax(High[pos],MathMax(haOpen,haClose));
         double haLow   = MathMin(Low[pos], MathMin(haOpen,haClose));
          
         if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
         else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                               Buffer3[pos]=haOpen;
                               Buffer4[pos]=haClose;   
                               uPac[pos]   = iMA(NULL,0,Upper_Ma_Period,0,Upper_Ma_Method,Upper_Ma_Price,pos);  
                               lPac[pos]   = iMA(NULL,0,Lower_Ma_Period,0,Lower_Ma_Method,Lower_Ma_Price,pos);             
     
          trend[pos] = trend[pos+1];
          if (Buffer3[pos] > Buffer4[pos] && haLow  < lPac[pos]) trend[pos] = -1;
          if (Buffer3[pos] < Buffer4[pos] && haHigh > uPac[pos]) trend[pos] =  1;
          
      } 
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1)   doAlert(whichBar,"up");
            if (trend[whichBar] ==-1)   doAlert(whichBar,"down");
         }         
      }
      return(0);
   }
          
   //
   //
   //
   //
   //
   
   int displace = -1; if (HAOnFirst) displace = 1;
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(pos = limit; pos >= 0; pos--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[pos]);
      int x = iBarShift(NULL,TimeFrame,Time[pos+displace]);
         uPac[pos]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Upper_Ma_Period,Lower_Ma_Period,Upper_Ma_Method,Lower_Ma_Method,Upper_Ma_Price,Lower_Ma_Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,4,y);
         lPac[pos]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Upper_Ma_Period,Lower_Ma_Period,Upper_Ma_Method,Lower_Ma_Method,Upper_Ma_Price,Lower_Ma_Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,5,y);
      if (x!=y)
      { 
         Buffer1[pos] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Upper_Ma_Period,Lower_Ma_Period,Upper_Ma_Method,Lower_Ma_Method,Upper_Ma_Price,Lower_Ma_Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,0,y);
         Buffer2[pos] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Upper_Ma_Period,Lower_Ma_Period,Upper_Ma_Method,Lower_Ma_Method,Upper_Ma_Price,Lower_Ma_Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,1,y);
         Buffer3[pos] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Upper_Ma_Period,Lower_Ma_Period,Upper_Ma_Method,Lower_Ma_Method,Upper_Ma_Price,Lower_Ma_Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,2,y);
         Buffer4[pos] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Upper_Ma_Period,Lower_Ma_Period,Upper_Ma_Method,Lower_Ma_Method,Upper_Ma_Price,Lower_Ma_Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,3,y);
       } 
       else
       {
         Buffer1[pos] = EMPTY_VALUE;
         Buffer2[pos] = EMPTY_VALUE;
         Buffer3[pos] = EMPTY_VALUE;
         Buffer4[pos] = EMPTY_VALUE;
       }
   }
   return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," PA Bars and channel ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " PA Bars and channel "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}
